<div [ngSwitch]="filterType">
  <mat-form-field *ngSwitchCase="'week_day'">
    <mat-select (selectionChange)="valueChange.emit($event.value)" [value]="value">
      <mat-option value="1" i18n>Sunday</mat-option>
      <mat-option value="2" i18n>Monday</mat-option>
      <mat-option value="3" i18n>Tuesday</mat-option>
      <mat-option value="4" i18n>Wednesday</mat-option>
      <mat-option value="5" i18n>Thursday</mat-option>
      <mat-option value="6" i18n>Friday</mat-option>
      <mat-option value="7" i18n>Saturday</mat-option>
    </mat-select>
  </mat-form-field>

  <div *ngSwitchCase="'isnull'">
    <mat-checkbox [checked]="getBoolean()" (change)="emitBoolean($event.checked)" arial-label="Is Null"></mat-checkbox>
  </div>

  <div *ngSwitchCase="'max'">
    <mat-checkbox [checked]="getBoolean()" (change)="emitBoolean($event.checked)" arial-label="Max (annotation-filter)"></mat-checkbox>
  </div>

  <div *ngSwitchCase="'min'">
    <mat-checkbox [checked]="getBoolean()" (change)="emitBoolean($event.checked)" arial-label="Min (annotation-filter)"></mat-checkbox>
  </div>

  <div *ngSwitchCase="'relative_range'">
    <mat-form-field>
      <input matInput value="{{ range }}" (keyup)="onRangeChange($event.currentTarget.value)" type="number"
             oninput="if (isNaN(parseInt(this.value))) this.value = 0; else this.value = parseInt(this.value);">
    </mat-form-field>

    <mat-form-field>
      <mat-select [value]="rangeUnit" (selectionChange)="onRangeUnitChange($event.value)">
        <mat-option *ngFor="let option of rangeUnitOpts" [value]="option.value">
          {{ option.display }}
        </mat-option>
      </mat-select>
    </mat-form-field>
  </div>

  <div *ngSwitchDefault [ngSwitch]="fieldType">

    <mat-form-field *ngSwitchCase="'DateField'">
      <input matInput [matDatepicker]="picker" [value]="date" (dateChange)="onDateChange($event.value.format('YYYY-MM-DD'))">
      <mat-datepicker-toggle matSuffix [for]="picker"></mat-datepicker-toggle>
      <mat-datepicker #picker></mat-datepicker>
    </mat-form-field>

    <div *ngSwitchCase="'DateTimeField'">
      <mat-form-field>
        <input matInput [matDatepicker]="picker" [value]="date" (dateChange)="onDateChange($event.value.format('YYYY-MM-DD'))">
        <mat-datepicker-toggle matSuffix [for]="picker"></mat-datepicker-toggle>
        <mat-datepicker #picker></mat-datepicker>
      </mat-form-field>
      <mat-form-field>
        <mat-select [value]="time" (selectionChange)="onTimeChange($event.value)">
          <mat-option *ngFor="let option of timeOpts" [value]="option.value">
            {{option.display}}
          </mat-option>
        </mat-select>
      </mat-form-field>
    </div>

    <div *ngSwitchCase="'BooleanField'">
      <mat-checkbox [checked]="getBoolean()" (change)="emitBoolean($event.checked)"></mat-checkbox>
    </div>

    <mat-form-field *ngSwitchDefault>
      <input matInput value="{{value}}" (keyup)="valueChange.emit($event.currentTarget.value)">
    </mat-form-field>

  </div>
</div>
